#include<bits/stdc++.h>
using namespace std;

char niska[1050];
int n, m;

int pozicija_steve(){
   for(int i=0; i<=m+1; i++){
      if(niska[i]=='S'){
         return i;
      }
   }
}

int br_polja_moze_nalevo(){
   int si=pozicija_steve(), a, b;
   for(int i=si; i>=0; i--){
      if(niska[i]=='X'){
         a=(si-i-1)/2;
         break;
      }
   }
   for(int i=si; i>=0; i--){
      if(niska[i]=='#'){
         b=si-i-1;
         break;
      }
   }
   return min(a, b);
}

int br_polja_moze_nadesno(){
   int si=pozicija_steve(), a, b;
   for(int i=si; i<=m+1; i++){
      if(niska[i]=='X'){
         b=(i-si-1)/2;
         break;
      }
   }
   for(int i=si; i<=m+1; i++){
      if(niska[i]=='*'){
         a=i-si-1;
         break;
      }
   }
   return min(a, b);
}

int main(){
   cin>>n>>m;
   niska[0]='*';
   for(int i=1; i<=m; i++)
      cin>>niska[i];
   niska[m+1]='*';
   cout<<br_polja_moze_nalevo()+br_polja_moze_nadesno()+1;
   return 0;
}